Index: FL/Fl_Tiled_Image.H
===================================================================
RCS file: /cvsroot/fltk/fltk/FL/Attic/Fl_Tiled_Image.H,v
retrieving revision 1.1.2.4
diff -u -r1.1.2.4 Fl_Tiled_Image.H
--- FL/Fl_Tiled_Image.H	30 Jan 2003 21:40:24 -0000	1.1.2.4
+++ FL/Fl_Tiled_Image.H	11 Apr 2004 03:48:20 -0000
@@ -47,6 +47,7 @@
   virtual void desaturate();
   virtual void draw(int X, int Y, int W, int H, int cx, int cy);
   void draw(int X, int Y) { draw(X, Y, w(), h(), 0, 0); }
+  Fl_Image *image() { return image_; }
 };
 
 #endif // !Fl_Tiled_Image_H
Index: documentation/Fl_Tiled_Image.html
===================================================================
RCS file: /cvsroot/fltk/fltk/documentation/Attic/Fl_Tiled_Image.html,v
retrieving revision 1.1.2.3
diff -u -r1.1.2.3 Fl_Tiled_Image.html
--- documentation/Fl_Tiled_Image.html	11 Dec 2001 16:03:11 -0000	1.1.2.3
+++ documentation/Fl_Tiled_Image.html	11 Apr 2004 03:48:20 -0000
@@ -40,6 +40,8 @@
 
 	<LI><A href="#Fl_Tiled_Image.~Fl_Tiled_Image">~Fl_Tiled_Image</A></LI>
 
+	<LI><A href="#Fl_Tiled_Image.image">image</A></LI>
+
 </UL>
 
 <H4><A name="Fl_Tiled_Image.Fl_Tiled_Image">Fl_Tiled_Image::Fl_Tiled_Image(Fl_Image *img, int W, int H);</A></H4>
@@ -51,5 +53,9 @@
 <P>The destructor free all memory and server resources that are used by
 the tiled image.</P>
 
+<H4><A name="Fl_Tiled_Image.image">Fl_Image *Fl_Tiled_Image::image();</A></H4>
+
+<P>Returns the image that will be tiled.</P>
+
 </BODY>
 </HTML>
Index: src/Fl_Scroll.cxx
===================================================================
RCS file: /cvsroot/fltk/fltk/src/Fl_Scroll.cxx,v
retrieving revision 1.7.2.6.2.9
diff -u -r1.7.2.6.2.9 Fl_Scroll.cxx
--- src/Fl_Scroll.cxx	11 Apr 2004 01:39:57 -0000	1.7.2.6.2.9
+++ src/Fl_Scroll.cxx	11 Apr 2004 03:48:20 -0000
@@ -24,7 +24,7 @@
 //
 
 #include <FL/Fl.H>
-#include <FL/Fl_Image.H>
+#include <FL/Fl_Tiled_Image.H>
 #include <FL/Fl_Scroll.H>
 #include <FL/fl_draw.H>
 
@@ -69,10 +69,10 @@
     case _FL_PLASTIC_UP_FRAME :
     case _FL_PLASTIC_DOWN_FRAME :
         if (s->parent() == (Fl_Group *)s->window() && Fl::scheme_bg_) {
-	  Fl::scheme_bg_->draw(X-(X%Fl::scheme_bg_->w()),
-	                       Y-(Y%Fl::scheme_bg_->h()),
-	                       W+Fl::scheme_bg_->w(),
-			       H+Fl::scheme_bg_->h());
+	  Fl::scheme_bg_->draw(X-(X%((Fl_Tiled_Image *)Fl::scheme_bg_)->image()->w()),
+	                       Y-(Y%((Fl_Tiled_Image *)Fl::scheme_bg_)->image()->h()),
+	                       W+((Fl_Tiled_Image *)Fl::scheme_bg_)->image()->w(),
+			       H+((Fl_Tiled_Image *)Fl::scheme_bg_)->image()->h());
 	  break;
         }
 
@@ -115,8 +115,27 @@
     draw_box(box(),x(),y(),w(),h(),color());
     draw_clip(this, X, Y, W, H);
   } else {
-    if (d & FL_DAMAGE_SCROLL) { // scroll the contents:
+    if (d & FL_DAMAGE_SCROLL) {
+      // scroll the contents:
       fl_scroll(X, Y, W, H, oldx-xposition_, oldy-yposition_, draw_clip, this);
+
+      // Erase the background as needed...
+      Fl_Widget*const* a = array();
+      int L, R, T, B;
+      L = 999999;
+      R = 0;
+      T = 999999;
+      B = 0;
+      for (int i=children()-2; i--; a++) {
+        if ((*a)->x() < L) L = (*a)->x();
+	if (((*a)->x() + (*a)->w()) > R) R = (*a)->x() + (*a)->w();
+        if ((*a)->y() < T) T = (*a)->y();
+	if (((*a)->y() + (*a)->h()) > B) B = (*a)->y() + (*a)->h();
+      }
+      if (L > X) draw_clip(this, X, Y, L - X, H);
+      if (R < (X + W)) draw_clip(this, R, Y, X + W - R, H);
+      if (T > Y) draw_clip(this, X, Y, W, T - Y);
+      if (B < (Y + H)) draw_clip(this, X, B, W, Y + H - B);
     }
     if (d & FL_DAMAGE_CHILD) { // draw damaged children
       fl_clip(X, Y, W, H);
